TITLE Mod file for component: Component(id=EIF_cond_exp_isfa_ista_pop_EIF type=EIF_cond_exp_isfa_ista)

COMMENT

    This NEURON file has been generated by org.neuroml.export (see https://github.com/NeuroML/org.neuroml.export)
         org.neuroml.export  v1.5.3
         org.neuroml.model   v1.5.3
         jLEMS               v0.9.9.0

ENDCOMMENT

NEURON {
    POINT_PROCESS EIF_cond_exp_isfa_ista_pop_EIF
    
    
    NONSPECIFIC_CURRENT i                    : To ensure v of section follows vI
    RANGE v_rest                            : parameter
    RANGE v_spike                           : parameter
    RANGE delta_T                           : parameter
    RANGE tau_w                             : parameter
    RANGE a                                 : parameter
    RANGE b                                 : parameter
    RANGE i_offset                          : parameter
    RANGE tau_refrac                        : parameter
    RANGE eif_threshold                     : parameter
    RANGE e_rev_E                           : parameter
    RANGE e_rev_I                           : parameter
    RANGE v_thresh                          : parameter
    RANGE tau_m                             : parameter
    RANGE v_reset                           : parameter
    RANGE cm                                : parameter
    RANGE tau_syn_E                         : parameter
    RANGE tau_syn_I                         : parameter
    RANGE v_init                            : parameter
    RANGE MSEC                              : parameter
    RANGE MVOLT                             : parameter
    RANGE NFARAD                            : parameter
    
    RANGE iSyn                              : exposure
    
    RANGE copy_v                           : copy of v on section
    
    RANGE delta_I                          : conditional derived var
    
}

UNITS {
    
    (nA) = (nanoamp)
    (uA) = (microamp)
    (mA) = (milliamp)
    (A) = (amp)
    (mV) = (millivolt)
    (mS) = (millisiemens)
    (uS) = (microsiemens)
    (molar) = (1/liter)
    (kHz) = (kilohertz)
    (mM) = (millimolar)
    (um) = (micrometer)
    (umol) = (micromole)
    (S) = (siemens)
    
}

PARAMETER {
    
    v_rest = -70.6 
    v_spike = -40 
    delta_T = 2 
    tau_w = 144 
    a = 0 
    b = 0.0805 
    i_offset = 0.6 
    tau_refrac = 5 
    eif_threshold = -40 
    e_rev_E = 0 
    e_rev_I = -80 
    v_thresh = -52 
    tau_m = 9.3667 
    v_reset = -68 
    cm = 0.281 
    tau_syn_E = 5 
    tau_syn_I = 5 
    v_init = -70.6 
    MSEC = 1 (ms)
    MVOLT = 1 (mV)
    NFARAD = 0.001 (microfarads)
}

ASSIGNED {
    v (mV)
    i (mA/cm2)
    
    copy_v (mV)
    
    
    iSyn (nA)                              : derived variable
    
    delta_I                                : conditional derived var...
    
    rate_w (/ms)
    
    rate_v (mV/ms)
    
}

STATE {
    regime_refractory (1)
    regime_integrating (1)
    vI (nA) 
    w  
    lastSpikeTime (ms) 
    
}

INITIAL {
    rates()
    rates() ? To ensure correct initialisation.
    
    regime_refractory = 0
    
    regime_integrating = 1
    
    net_send(0, 1) : go to NET_RECEIVE block, flag 1, for initial state
    
    w = 0
    
}

BREAKPOINT {
    
    SOLVE states METHOD cnexp
    
    
    copy_v = v
    i = vI * cm
}

NET_RECEIVE(flag) {
    
    if (flag == 1) { : Setting watch condition for regime_refractory
        WATCH (t >  lastSpikeTime  + (  tau_refrac  *  MSEC  )) 5002
    }
    
    if (regime_refractory == 1 && flag == 5002) { : Setting actions for regime_refractory
    
            : State assignments
    
            : Change regime flags
            regime_refractory = 0
            regime_integrating = 1
    
            : OnEntry to Regime: integrating (initial = true)
    }
    
    if (flag == 1) { : Setting watch condition for regime_integrating
        WATCH (v >  eif_threshold  *  MVOLT) 5003
    }
    
    if (regime_integrating == 1 && flag == 5003) { : Setting actions for regime_integrating
    
            : State assignments
    
            : Change regime flags
            regime_integrating = 0
            regime_refractory = 1
    
            : OnEntry to Regime: refractory (initial = false)
    
            lastSpikeTime = t
    
            v = v_reset  *  MVOLT
    
            w = w  +  b
    }
    if (flag == 1) { : Set initial states
    
        v = v_init  *  MVOLT
    }
    
}

DERIVATIVE states {
    rates()
    w' = rate_w 
    
}

PROCEDURE rates() {
    
    ? DerivedVariable is based on path: synapses[*]/i, on: Component(id=EIF_cond_exp_isfa_ista_pop_EIF type=EIF_cond_exp_isfa_ista), from synapses; null
    iSyn = 0 ? Was: synapses[*]_i but insertion of currents from external attachments not yet supported ? path based, prefix = 
    
    if (delta_T  > 0)  { 
        delta_I = delta_T  * exp(((v /   MVOLT  ) -   v_thresh  ) /   delta_T  ) ? evaluable cdv
    } else if (delta_T  == 0)  { 
        delta_I = 0 ? evaluable cdv
    }
    
    rate_w = 0 + regime_refractory * ((1 /   tau_w  ) * (  a   * ((v /   MVOLT  ) -   v_rest  ) -   w  ) /  MSEC) + regime_integrating * ((1 /   tau_w  ) * (  a   * ((v /   MVOLT  ) -   v_rest  ) -   w  ) /  MSEC) ? Note units of all quantities used here need to be consistent!
    rate_v = 0 + regime_integrating * ((  MVOLT   * ((-1 * ((v /   MVOLT  ) -   v_rest  ) +   delta_I  ) /  tau_m  + (  i_offset   -   w  ) /   cm  ) /   MSEC  ) + (  iSyn   / (  cm   *   NFARAD  ))) ? Note units of all quantities used here need to be consistent!
    
    vI = -1 * rate_v
     
    
}

