TITLE Mod file for component: Component(id=HH_cond_exp_pop_HH_cond_exp type=HH_cond_exp)

COMMENT

    This NEURON file has been generated by org.neuroml.export (see https://github.com/NeuroML/org.neuroml.export)
         org.neuroml.export  v1.5.3
         org.neuroml.model   v1.5.3
         jLEMS               v0.9.9.0

ENDCOMMENT

NEURON {
    POINT_PROCESS HH_cond_exp_pop_HH_cond_exp
    
    
    NONSPECIFIC_CURRENT i                    : To ensure v of section follows vI
    RANGE gbar_K                            : parameter
    RANGE gbar_Na                           : parameter
    RANGE g_leak                            : parameter
    RANGE e_rev_K                           : parameter
    RANGE e_rev_Na                          : parameter
    RANGE e_rev_leak                        : parameter
    RANGE v_offset                          : parameter
    RANGE e_rev_E                           : parameter
    RANGE e_rev_I                           : parameter
    RANGE cm                                : parameter
    RANGE i_offset                          : parameter
    RANGE tau_syn_E                         : parameter
    RANGE tau_syn_I                         : parameter
    RANGE v_init                            : parameter
    RANGE MSEC                              : parameter
    RANGE MVOLT                             : parameter
    RANGE NFARAD                            : parameter
    
    RANGE iSyn                              : exposure
    
    RANGE copy_v                           : copy of v on section
    RANGE iLeak                             : derived variable
    RANGE iNa                               : derived variable
    RANGE iK                                : derived variable
    RANGE iMemb                             : derived variable
    RANGE alpham                            : derived variable
    RANGE betam                             : derived variable
    RANGE alphah                            : derived variable
    RANGE betah                             : derived variable
    RANGE alphan                            : derived variable
    RANGE betan                             : derived variable
    
}

UNITS {
    
    (nA) = (nanoamp)
    (uA) = (microamp)
    (mA) = (milliamp)
    (A) = (amp)
    (mV) = (millivolt)
    (mS) = (millisiemens)
    (uS) = (microsiemens)
    (molar) = (1/liter)
    (kHz) = (kilohertz)
    (mM) = (millimolar)
    (um) = (micrometer)
    (umol) = (micromole)
    (S) = (siemens)
    
}

PARAMETER {
    
    gbar_K = 6 
    gbar_Na = 20 
    g_leak = 0.01 
    e_rev_K = -90 
    e_rev_Na = 50 
    e_rev_leak = -65 
    v_offset = -63 
    e_rev_E = 0 
    e_rev_I = -80 
    cm = 0.2 
    i_offset = 0.2 
    tau_syn_E = 0.2 
    tau_syn_I = 2 
    v_init = -65 
    MSEC = 1 (ms)
    MVOLT = 1 (mV)
    NFARAD = 0.001 (microfarads)
}

ASSIGNED {
    v (mV)
    i (mA/cm2)
    
    copy_v (mV)
    
    
    iSyn (nA)                              : derived variable
    
    iLeak                                  : derived variable
    
    iNa                                    : derived variable
    
    iK                                     : derived variable
    
    iMemb                                  : derived variable
    
    alpham                                 : derived variable
    
    betam                                  : derived variable
    
    alphah                                 : derived variable
    
    betah                                  : derived variable
    
    alphan                                 : derived variable
    
    betan                                  : derived variable
    rate_v (mV/ms)
    rate_m (/ms)
    rate_h (/ms)
    rate_n (/ms)
    
}

STATE {
    vI (nA) 
    m  
    h  
    n  
    
}

INITIAL {
    rates()
    rates() ? To ensure correct initialisation.
    
    net_send(0, 1) : go to NET_RECEIVE block, flag 1, for initial state
    
}

BREAKPOINT {
    
    SOLVE states METHOD cnexp
    
    
    copy_v = v
    i = vI * cm
}

NET_RECEIVE(flag) {
    if (flag == 1) { : Set initial states
    
        v = v_init  *  MVOLT
    }
    
}

DERIVATIVE states {
    rates()
    m' = rate_m 
    h' = rate_h 
    n' = rate_n 
    
}

PROCEDURE rates() {
    
    ? DerivedVariable is based on path: synapses[*]/i, on: Component(id=HH_cond_exp_pop_HH_cond_exp type=HH_cond_exp), from synapses; null
    iSyn = 0 ? Was: synapses[*]_i but insertion of currents from external attachments not yet supported ? path based, prefix = 
    
    iLeak = g_leak  * (  e_rev_leak   - (v /   MVOLT  )) ? evaluable
    iNa = gbar_Na  * (  m   *  m  *   m  ) *  h  * (  e_rev_Na   - (v /   MVOLT  )) ? evaluable
    iK = gbar_K  * (  n   *  n  *  n  *   n  ) * (  e_rev_K   - (v /   MVOLT  )) ? evaluable
    iMemb = iLeak  +  iNa  +  iK  +  i_offset ? evaluable
    alpham = 0.32 * (13 - (v /   MVOLT  ) +   v_offset  ) / (exp((13 - (v /   MVOLT  ) +   v_offset  ) / 4.0) - 1) ? evaluable
    betam = 0.28 * ((v /   MVOLT  ) -  v_offset  - 40) / (exp(((v /   MVOLT  ) -  v_offset  - 40) / 5.0) - 1) ? evaluable
    alphah = 0.128 * exp((17 - (v /   MVOLT  ) +   v_offset  ) / 18.0) ? evaluable
    betah = 4.0 / (1 + exp((40 - (v /   MVOLT  ) +   v_offset  ) / 5)) ? evaluable
    alphan = 0.032 * (15 - (v /   MVOLT  ) +   v_offset  ) / (exp((15 - (v /   MVOLT  ) +   v_offset  ) / 5) - 1) ? evaluable
    betan = 0.5 * exp((10 - (v /   MVOLT  ) +   v_offset  ) / 40) ? evaluable
    rate_v = (  MVOLT   * (  iMemb   /   cm  ) /   MSEC  ) + (  iSyn   / (  cm   *   NFARAD  )) ? Note units of all quantities used here need to be consistent!
    rate_m = (  alpham   * (1 -   m  ) -  betam  *   m  ) /  MSEC ? Note units of all quantities used here need to be consistent!
    rate_h = (  alphah   * (1 -   h  ) -  betah  *   h  ) /  MSEC ? Note units of all quantities used here need to be consistent!
    rate_n = (  alphan   * (1 -   n  ) -  betan  *   n  ) /  MSEC ? Note units of all quantities used here need to be consistent!
    
    vI = -1 * rate_v
     
    
}

