'''
Neuron simulator export for:

Components:
    IF_curr_alpha_pop_IF_curr_alpha (Type: IF_curr_alpha:  tau_refrac=10.0 (dimensionless) v_thresh=-52.0 (dimensionless) tau_m=20.0 (dimensionless) v_rest=-65.0 (dimensionless) v_reset=-62.0 (dimensionless) cm=1.0 (dimensionless) i_offset=0.9 (dimensionless) tau_syn_E=2.0 (dimensionless) tau_syn_I=5.0 (dimensionless) v_init=-65.0 (dimensionless) MSEC=0.001 (SI time) MVOLT=0.001 (SI voltage) NFARAD=1.0E-9 (SI capacitance))
    IF_curr_exp_pop_IF_curr_exp (Type: IF_curr_exp:  tau_refrac=8.0 (dimensionless) v_thresh=-50.0 (dimensionless) tau_m=20.0 (dimensionless) v_rest=-65.0 (dimensionless) v_reset=-70.0 (dimensionless) cm=1.0 (dimensionless) i_offset=1.0 (dimensionless) tau_syn_E=2.0 (dimensionless) tau_syn_I=5.0 (dimensionless) v_init=-65.0 (dimensionless) MSEC=0.001 (SI time) MVOLT=0.001 (SI voltage) NFARAD=1.0E-9 (SI capacitance))
    IF_cond_alpha_pop_IF_cond_alpha (Type: IF_cond_alpha:  e_rev_E=0.0 (dimensionless) e_rev_I=-70.0 (dimensionless) tau_refrac=5.0 (dimensionless) v_thresh=-50.0 (dimensionless) tau_m=20.0 (dimensionless) v_rest=-65.0 (dimensionless) v_reset=-65.0 (dimensionless) cm=1.0 (dimensionless) i_offset=0.9 (dimensionless) tau_syn_E=2.0 (dimensionless) tau_syn_I=5.0 (dimensionless) v_init=-65.0 (dimensionless) MSEC=0.001 (SI time) MVOLT=0.001 (SI voltage) NFARAD=1.0E-9 (SI capacitance))
    IF_cond_alpha_pop_post2 (Type: IF_cond_alpha:  e_rev_E=0.0 (dimensionless) e_rev_I=-70.0 (dimensionless) tau_refrac=10.0 (dimensionless) v_thresh=-52.0 (dimensionless) tau_m=20.0 (dimensionless) v_rest=-65.0 (dimensionless) v_reset=-62.0 (dimensionless) cm=1.0 (dimensionless) i_offset=0.0 (dimensionless) tau_syn_E=5.0 (dimensionless) tau_syn_I=0.5 (dimensionless) v_init=-65.0 (dimensionless) MSEC=0.001 (SI time) MVOLT=0.001 (SI voltage) NFARAD=1.0E-9 (SI capacitance))
    IF_cond_exp_pop_IF_cond_exp (Type: IF_cond_exp:  e_rev_E=0.0 (dimensionless) e_rev_I=-70.0 (dimensionless) tau_refrac=5.0 (dimensionless) v_thresh=-52.0 (dimensionless) tau_m=20.0 (dimensionless) v_rest=-65.0 (dimensionless) v_reset=-68.0 (dimensionless) cm=1.0 (dimensionless) i_offset=1.0 (dimensionless) tau_syn_E=2.0 (dimensionless) tau_syn_I=5.0 (dimensionless) v_init=-65.0 (dimensionless) MSEC=0.001 (SI time) MVOLT=0.001 (SI voltage) NFARAD=1.0E-9 (SI capacitance))
    IF_cond_exp_pop_post1 (Type: IF_cond_exp:  e_rev_E=0.0 (dimensionless) e_rev_I=-70.0 (dimensionless) tau_refrac=10.0 (dimensionless) v_thresh=-52.0 (dimensionless) tau_m=20.0 (dimensionless) v_rest=-65.0 (dimensionless) v_reset=-62.0 (dimensionless) cm=1.0 (dimensionless) i_offset=0.0 (dimensionless) tau_syn_E=5.0 (dimensionless) tau_syn_I=5.0 (dimensionless) v_init=-65.0 (dimensionless) MSEC=0.001 (SI time) MVOLT=0.001 (SI voltage) NFARAD=1.0E-9 (SI capacitance))
    EIF_cond_exp_isfa_ista_pop_EIF (Type: EIF_cond_exp_isfa_ista:  v_rest=-70.6 (dimensionless) v_spike=-40.0 (dimensionless) delta_T=2.0 (dimensionless) tau_w=144.0 (dimensionless) a=0.0 (dimensionless) b=0.0805 (dimensionless) i_offset=0.6 (dimensionless) tau_refrac=5.0 (dimensionless) eif_threshold=-40.0 (dimensionless) e_rev_E=0.0 (dimensionless) e_rev_I=-80.0 (dimensionless) v_thresh=-52.0 (dimensionless) tau_m=9.3667 (dimensionless) v_reset=-68.0 (dimensionless) cm=0.281 (dimensionless) tau_syn_E=5.0 (dimensionless) tau_syn_I=5.0 (dimensionless) v_init=-70.6 (dimensionless) MSEC=0.001 (SI time) MVOLT=0.001 (SI voltage) NFARAD=1.0E-9 (SI capacitance))
    HH_cond_exp_pop_HH_cond_exp (Type: HH_cond_exp:  gbar_K=6.0 (dimensionless) gbar_Na=20.0 (dimensionless) g_leak=0.01 (dimensionless) e_rev_K=-90.0 (dimensionless) e_rev_Na=50.0 (dimensionless) e_rev_leak=-65.0 (dimensionless) v_offset=-63.0 (dimensionless) e_rev_E=0.0 (dimensionless) e_rev_I=-80.0 (dimensionless) cm=0.2 (dimensionless) i_offset=0.2 (dimensionless) tau_syn_E=0.2 (dimensionless) tau_syn_I=2.0 (dimensionless) v_init=-65.0 (dimensionless) MSEC=0.001 (SI time) MVOLT=0.001 (SI voltage) NFARAD=1.0E-9 (SI capacitance))
    syn__pop_EIF__TO__pop_post1 (Type: expCondSynapse:  e_rev=0.0 (dimensionless) tau_syn=5.0 (dimensionless) MSEC=0.001 (SI time) MVOLT=0.001 (SI voltage) NAMP=1.0E-9 (SI current))
    syn__pop_EIF__TO__pop_post2 (Type: alphaCondSynapse:  e_rev=0.0 (dimensionless) tau_syn=5.0 (dimensionless) MSEC=0.001 (SI time) MVOLT=0.001 (SI voltage) NAMP=1.0E-9 (SI current))
    network (Type: network)
    Sim_PyNN_NeuroML2_Export (Type: Simulation:  length=0.5 (SI time) step=1.0E-6 (SI time))


    This NEURON file has been generated by org.neuroml.export (see https://github.com/NeuroML/org.neuroml.export)
         org.neuroml.export  v1.5.3
         org.neuroml.model   v1.5.3
         jLEMS               v0.9.9.0

'''

import neuron

import time

import hashlib
h = neuron.h
h.load_file("stdlib.hoc")

h.load_file("stdgui.hoc")

h("objref p")
h("p = new PythonObject()")

class NeuronSimulation():

    def __init__(self, tstop, dt, seed=12345):

        print("\n    Starting simulation in NEURON generated from NeuroML2 model...\n")

        self.seed = seed
        self.randoms = []
        self.next_global_id = 0  # Used in Random123 classes for elements using random(), etc. 

        self.next_spiking_input_id = 0  # Used in Random123 classes for elements using random(), etc. 

        '''
        Adding simulation Component(id=Sim_PyNN_NeuroML2_Export type=Simulation) of network/component: network (Type: network)
        
        '''
        # ######################   Population: pop_IF_curr_alpha
        print("Population pop_IF_curr_alpha contains 1 instance(s) of component: IF_curr_alpha_pop_IF_curr_alpha of type: IF_curr_alpha")

        h(" {n_pop_IF_curr_alpha = 1} ")
        '''
        Population pop_IF_curr_alpha contains instances of Component(id=IF_curr_alpha_pop_IF_curr_alpha type=IF_curr_alpha)
        whose dynamics will be implemented as a mechanism (IF_curr_alpha_pop_IF_curr_alpha) in a mod file
        '''
        h(" create pop_IF_curr_alpha[1]")
        h(" objectvar m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[1] ")

        for i in range(int(h.n_pop_IF_curr_alpha)):
            h.pop_IF_curr_alpha[i].L = 10.0
            h.pop_IF_curr_alpha[i](0.5).diam = 10.0
            h.pop_IF_curr_alpha[i](0.5).cm = 318.3098861837907
            h.pop_IF_curr_alpha[i].push()
            h(" pop_IF_curr_alpha[%i]  { m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[%i] = new IF_curr_alpha_pop_IF_curr_alpha(0.5) } "%(i,i))

            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].tau_refrac = 10.0
            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].v_thresh = -52.0
            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].tau_m = 20.0
            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].v_rest = -65.0
            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].v_reset = -62.0
            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].cm = 1.0
            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].i_offset = 0.9
            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].tau_syn_E = 2.0
            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].tau_syn_I = 5.0
            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].v_init = -65.0
            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].MSEC = 1.0
            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].MVOLT = 1.0
            h.m_IF_curr_alpha_pop_IF_curr_alpha_pop_IF_curr_alpha[i].NFARAD = 0.001
            h.pop_section()

            self.next_global_id+=1

        h(" pop_IF_curr_alpha[0] { pt3dclear() } ")
        h(" pop_IF_curr_alpha[0] { pt3dadd(0., 0. + (5), 0., 10) } ")
        h(" pop_IF_curr_alpha[0] { pt3dadd(0., 0. + (-5), 0., 10) } ")

        # ######################   Population: pop_IF_curr_exp
        print("Population pop_IF_curr_exp contains 1 instance(s) of component: IF_curr_exp_pop_IF_curr_exp of type: IF_curr_exp")

        h(" {n_pop_IF_curr_exp = 1} ")
        '''
        Population pop_IF_curr_exp contains instances of Component(id=IF_curr_exp_pop_IF_curr_exp type=IF_curr_exp)
        whose dynamics will be implemented as a mechanism (IF_curr_exp_pop_IF_curr_exp) in a mod file
        '''
        h(" create pop_IF_curr_exp[1]")
        h(" objectvar m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[1] ")

        for i in range(int(h.n_pop_IF_curr_exp)):
            h.pop_IF_curr_exp[i].L = 10.0
            h.pop_IF_curr_exp[i](0.5).diam = 10.0
            h.pop_IF_curr_exp[i](0.5).cm = 318.3098861837907
            h.pop_IF_curr_exp[i].push()
            h(" pop_IF_curr_exp[%i]  { m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[%i] = new IF_curr_exp_pop_IF_curr_exp(0.5) } "%(i,i))

            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].tau_refrac = 8.0
            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].v_thresh = -50.0
            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].tau_m = 20.0
            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].v_rest = -65.0
            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].v_reset = -70.0
            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].cm = 1.0
            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].i_offset = 1.0
            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].tau_syn_E = 2.0
            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].tau_syn_I = 5.0
            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].v_init = -65.0
            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].MSEC = 1.0
            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].MVOLT = 1.0
            h.m_IF_curr_exp_pop_IF_curr_exp_pop_IF_curr_exp[i].NFARAD = 0.001
            h.pop_section()

            self.next_global_id+=1

        h(" pop_IF_curr_exp[0] { pt3dclear() } ")
        h(" pop_IF_curr_exp[0] { pt3dadd(0., 0. + (5), 0., 10) } ")
        h(" pop_IF_curr_exp[0] { pt3dadd(0., 0. + (-5), 0., 10) } ")

        # ######################   Population: pop_IF_cond_alpha
        print("Population pop_IF_cond_alpha contains 1 instance(s) of component: IF_cond_alpha_pop_IF_cond_alpha of type: IF_cond_alpha")

        h(" {n_pop_IF_cond_alpha = 1} ")
        '''
        Population pop_IF_cond_alpha contains instances of Component(id=IF_cond_alpha_pop_IF_cond_alpha type=IF_cond_alpha)
        whose dynamics will be implemented as a mechanism (IF_cond_alpha_pop_IF_cond_alpha) in a mod file
        '''
        h(" create pop_IF_cond_alpha[1]")
        h(" objectvar m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[1] ")

        for i in range(int(h.n_pop_IF_cond_alpha)):
            h.pop_IF_cond_alpha[i].L = 10.0
            h.pop_IF_cond_alpha[i](0.5).diam = 10.0
            h.pop_IF_cond_alpha[i](0.5).cm = 318.3098861837907
            h.pop_IF_cond_alpha[i].push()
            h(" pop_IF_cond_alpha[%i]  { m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[%i] = new IF_cond_alpha_pop_IF_cond_alpha(0.5) } "%(i,i))

            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].e_rev_E = 0.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].e_rev_I = -70.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].tau_refrac = 5.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].v_thresh = -50.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].tau_m = 20.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].v_rest = -65.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].v_reset = -65.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].cm = 1.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].i_offset = 0.9
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].tau_syn_E = 2.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].tau_syn_I = 5.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].v_init = -65.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].MSEC = 1.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].MVOLT = 1.0
            h.m_IF_cond_alpha_pop_IF_cond_alpha_pop_IF_cond_alpha[i].NFARAD = 0.001
            h.pop_section()

            self.next_global_id+=1

        h(" pop_IF_cond_alpha[0] { pt3dclear() } ")
        h(" pop_IF_cond_alpha[0] { pt3dadd(0., 0. + (5), 0., 10) } ")
        h(" pop_IF_cond_alpha[0] { pt3dadd(0., 0. + (-5), 0., 10) } ")

        # ######################   Population: pop_IF_cond_exp
        print("Population pop_IF_cond_exp contains 1 instance(s) of component: IF_cond_exp_pop_IF_cond_exp of type: IF_cond_exp")

        h(" {n_pop_IF_cond_exp = 1} ")
        '''
        Population pop_IF_cond_exp contains instances of Component(id=IF_cond_exp_pop_IF_cond_exp type=IF_cond_exp)
        whose dynamics will be implemented as a mechanism (IF_cond_exp_pop_IF_cond_exp) in a mod file
        '''
        h(" create pop_IF_cond_exp[1]")
        h(" objectvar m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[1] ")

        for i in range(int(h.n_pop_IF_cond_exp)):
            h.pop_IF_cond_exp[i].L = 10.0
            h.pop_IF_cond_exp[i](0.5).diam = 10.0
            h.pop_IF_cond_exp[i](0.5).cm = 318.3098861837907
            h.pop_IF_cond_exp[i].push()
            h(" pop_IF_cond_exp[%i]  { m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[%i] = new IF_cond_exp_pop_IF_cond_exp(0.5) } "%(i,i))

            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].e_rev_E = 0.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].e_rev_I = -70.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].tau_refrac = 5.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].v_thresh = -52.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].tau_m = 20.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].v_rest = -65.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].v_reset = -68.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].cm = 1.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].i_offset = 1.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].tau_syn_E = 2.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].tau_syn_I = 5.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].v_init = -65.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].MSEC = 1.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].MVOLT = 1.0
            h.m_IF_cond_exp_pop_IF_cond_exp_pop_IF_cond_exp[i].NFARAD = 0.001
            h.pop_section()

            self.next_global_id+=1

        h(" pop_IF_cond_exp[0] { pt3dclear() } ")
        h(" pop_IF_cond_exp[0] { pt3dadd(0., 0. + (5), 0., 10) } ")
        h(" pop_IF_cond_exp[0] { pt3dadd(0., 0. + (-5), 0., 10) } ")

        # ######################   Population: pop_EIF
        print("Population pop_EIF contains 1 instance(s) of component: EIF_cond_exp_isfa_ista_pop_EIF of type: EIF_cond_exp_isfa_ista")

        h(" {n_pop_EIF = 1} ")
        '''
        Population pop_EIF contains instances of Component(id=EIF_cond_exp_isfa_ista_pop_EIF type=EIF_cond_exp_isfa_ista)
        whose dynamics will be implemented as a mechanism (EIF_cond_exp_isfa_ista_pop_EIF) in a mod file
        '''
        h(" create pop_EIF[1]")
        h(" objectvar m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[1] ")

        for i in range(int(h.n_pop_EIF)):
            h.pop_EIF[i].L = 10.0
            h.pop_EIF[i](0.5).diam = 10.0
            h.pop_EIF[i](0.5).cm = 89.4450780176452
            h.pop_EIF[i].push()
            h(" pop_EIF[%i]  { m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[%i] = new EIF_cond_exp_isfa_ista_pop_EIF(0.5) } "%(i,i))

            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].v_rest = -70.6
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].v_spike = -40.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].delta_T = 2.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].tau_w = 144.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].a = 0.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].b = 0.0805
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].i_offset = 0.6
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].tau_refrac = 5.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].eif_threshold = -40.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].e_rev_E = 0.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].e_rev_I = -80.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].v_thresh = -52.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].tau_m = 9.3667
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].v_reset = -68.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].cm = 0.281
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].tau_syn_E = 5.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].tau_syn_I = 5.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].v_init = -70.6
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].MSEC = 1.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].MVOLT = 1.0
            h.m_EIF_cond_exp_isfa_ista_pop_EIF_pop_EIF[i].NFARAD = 0.001
            h.pop_section()

            self.next_global_id+=1

        h(" pop_EIF[0] { pt3dclear() } ")
        h(" pop_EIF[0] { pt3dadd(0., 0. + (5), 0., 10) } ")
        h(" pop_EIF[0] { pt3dadd(0., 0. + (-5), 0., 10) } ")

        # ######################   Population: pop_HH_cond_exp
        print("Population pop_HH_cond_exp contains 1 instance(s) of component: HH_cond_exp_pop_HH_cond_exp of type: HH_cond_exp")

        h(" {n_pop_HH_cond_exp = 1} ")
        '''
        Population pop_HH_cond_exp contains instances of Component(id=HH_cond_exp_pop_HH_cond_exp type=HH_cond_exp)
        whose dynamics will be implemented as a mechanism (HH_cond_exp_pop_HH_cond_exp) in a mod file
        '''
        h(" create pop_HH_cond_exp[1]")
        h(" objectvar m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[1] ")

        for i in range(int(h.n_pop_HH_cond_exp)):
            h.pop_HH_cond_exp[i].L = 10.0
            h.pop_HH_cond_exp[i](0.5).diam = 10.0
            h.pop_HH_cond_exp[i](0.5).cm = 63.66197723675815
            h.pop_HH_cond_exp[i].push()
            h(" pop_HH_cond_exp[%i]  { m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[%i] = new HH_cond_exp_pop_HH_cond_exp(0.5) } "%(i,i))

            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].gbar_K = 6.0
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].gbar_Na = 20.0
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].g_leak = 0.01
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].e_rev_K = -90.0
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].e_rev_Na = 50.0
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].e_rev_leak = -65.0
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].v_offset = -63.0
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].e_rev_E = 0.0
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].e_rev_I = -80.0
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].cm = 0.2
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].i_offset = 0.2
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].tau_syn_E = 0.2
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].tau_syn_I = 2.0
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].v_init = -65.0
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].MSEC = 1.0
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].MVOLT = 1.0
            h.m_HH_cond_exp_pop_HH_cond_exp_pop_HH_cond_exp[i].NFARAD = 0.001
            h.pop_section()

            self.next_global_id+=1

        h(" pop_HH_cond_exp[0] { pt3dclear() } ")
        h(" pop_HH_cond_exp[0] { pt3dadd(0., 0. + (5), 0., 10) } ")
        h(" pop_HH_cond_exp[0] { pt3dadd(0., 0. + (-5), 0., 10) } ")

        # ######################   Population: pop_post1
        print("Population pop_post1 contains 1 instance(s) of component: IF_cond_exp_pop_post1 of type: IF_cond_exp")

        h(" {n_pop_post1 = 1} ")
        '''
        Population pop_post1 contains instances of Component(id=IF_cond_exp_pop_post1 type=IF_cond_exp)
        whose dynamics will be implemented as a mechanism (IF_cond_exp_pop_post1) in a mod file
        '''
        h(" create pop_post1[1]")
        h(" objectvar m_IF_cond_exp_pop_post1_pop_post1[1] ")

        for i in range(int(h.n_pop_post1)):
            h.pop_post1[i].L = 10.0
            h.pop_post1[i](0.5).diam = 10.0
            h.pop_post1[i](0.5).cm = 318.3098861837907
            h.pop_post1[i].push()
            h(" pop_post1[%i]  { m_IF_cond_exp_pop_post1_pop_post1[%i] = new IF_cond_exp_pop_post1(0.5) } "%(i,i))

            h.m_IF_cond_exp_pop_post1_pop_post1[i].e_rev_E = 0.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].e_rev_I = -70.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].tau_refrac = 10.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].v_thresh = -52.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].tau_m = 20.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].v_rest = -65.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].v_reset = -62.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].cm = 1.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].i_offset = 0.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].tau_syn_E = 5.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].tau_syn_I = 5.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].v_init = -65.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].MSEC = 1.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].MVOLT = 1.0
            h.m_IF_cond_exp_pop_post1_pop_post1[i].NFARAD = 0.001
            h.pop_section()

            self.next_global_id+=1

        h(" pop_post1[0] { pt3dclear() } ")
        h(" pop_post1[0] { pt3dadd(0., 0. + (5), 0., 10) } ")
        h(" pop_post1[0] { pt3dadd(0., 0. + (-5), 0., 10) } ")

        # ######################   Population: pop_post2
        print("Population pop_post2 contains 1 instance(s) of component: IF_cond_alpha_pop_post2 of type: IF_cond_alpha")

        h(" {n_pop_post2 = 1} ")
        '''
        Population pop_post2 contains instances of Component(id=IF_cond_alpha_pop_post2 type=IF_cond_alpha)
        whose dynamics will be implemented as a mechanism (IF_cond_alpha_pop_post2) in a mod file
        '''
        h(" create pop_post2[1]")
        h(" objectvar m_IF_cond_alpha_pop_post2_pop_post2[1] ")

        for i in range(int(h.n_pop_post2)):
            h.pop_post2[i].L = 10.0
            h.pop_post2[i](0.5).diam = 10.0
            h.pop_post2[i](0.5).cm = 318.3098861837907
            h.pop_post2[i].push()
            h(" pop_post2[%i]  { m_IF_cond_alpha_pop_post2_pop_post2[%i] = new IF_cond_alpha_pop_post2(0.5) } "%(i,i))

            h.m_IF_cond_alpha_pop_post2_pop_post2[i].e_rev_E = 0.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].e_rev_I = -70.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].tau_refrac = 10.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].v_thresh = -52.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].tau_m = 20.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].v_rest = -65.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].v_reset = -62.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].cm = 1.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].i_offset = 0.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].tau_syn_E = 5.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].tau_syn_I = 0.5
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].v_init = -65.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].MSEC = 1.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].MVOLT = 1.0
            h.m_IF_cond_alpha_pop_post2_pop_post2[i].NFARAD = 0.001
            h.pop_section()

            self.next_global_id+=1

        h(" pop_post2[0] { pt3dclear() } ")
        h(" pop_post2[0] { pt3dadd(0., 0. + (5), 0., 10) } ")
        h(" pop_post2[0] { pt3dadd(0., 0. + (-5), 0., 10) } ")

        # ######################   Projection: pop_EIF__TO__pop_post1
        print("Adding projection: pop_EIF__TO__pop_post1, from pop_EIF to pop_post1 with synapse syn__pop_EIF__TO__pop_post1, 1 connection(s)")

        # Connection 0: cell 0, seg 0 (0.5) [0.5 on pop_EIF[0]] -> cell 0, seg 0 (0.5) [0.5 on pop_post1[0]], weight: 0.01, delay 10.0
        h("objectvar syn_pop_post1_0_0_syn__pop_EIF__TO__pop_post1_0")
        h("pop_post1[0] syn_pop_post1_0_0_syn__pop_EIF__TO__pop_post1_0 = new syn__pop_EIF__TO__pop_post1(0.5)")
        h("objectvar nc_syn_pop_post1_0_0_syn__pop_EIF__TO__pop_post1_0_0")
        h("pop_EIF[0] nc_syn_pop_post1_0_0_syn__pop_EIF__TO__pop_post1_0_0 = new NetCon(&v(0.5), syn_pop_post1_0_0_syn__pop_EIF__TO__pop_post1_0, -40.0, 10.0, 0.01)")  

        # ######################   Projection: pop_EIF__TO__pop_post2
        print("Adding projection: pop_EIF__TO__pop_post2, from pop_EIF to pop_post2 with synapse syn__pop_EIF__TO__pop_post2, 1 connection(s)")

        # Connection 0: cell 0, seg 0 (0.5) [0.5 on pop_EIF[0]] -> cell 0, seg 0 (0.5) [0.5 on pop_post2[0]], weight: 0.005, delay 20.0
        h("objectvar syn_pop_post2_0_0_syn__pop_EIF__TO__pop_post2_0")
        h("pop_post2[0] syn_pop_post2_0_0_syn__pop_EIF__TO__pop_post2_0 = new syn__pop_EIF__TO__pop_post2(0.5)")
        h("objectvar nc_syn_pop_post2_0_0_syn__pop_EIF__TO__pop_post2_0_0")
        h("pop_EIF[0] nc_syn_pop_post2_0_0_syn__pop_EIF__TO__pop_post2_0_0 = new NetCon(&v(0.5), syn_pop_post2_0_0_syn__pop_EIF__TO__pop_post2_0, -40.0, 20.0, 0.005)")  

        trec = h.Vector()
        trec.record(h._ref_t)

        h.tstop = tstop

        h.dt = dt

        h.steps_per_ms = 1/h.dt



        # ######################   File to save: pop_IF_curr_exp_v.dat (OF_pop_IF_curr_exp_v)
        # Column: pop_IF_curr_exp/0/IF_curr_exp_pop_IF_curr_exp/v
        h(' objectvar v_pop_IF_curr_exp_0_IF_curr_exp_pop_IF_curr_exp_v_OF_pop_IF_curr_exp_v ')
        h(' { v_pop_IF_curr_exp_0_IF_curr_exp_pop_IF_curr_exp_v_OF_pop_IF_curr_exp_v = new Vector() } ')
        h(' { v_pop_IF_curr_exp_0_IF_curr_exp_pop_IF_curr_exp_v_OF_pop_IF_curr_exp_v.record(&pop_IF_curr_exp[0].v(0.5)) } ')
        h.v_pop_IF_curr_exp_0_IF_curr_exp_pop_IF_curr_exp_v_OF_pop_IF_curr_exp_v.resize((h.tstop * h.steps_per_ms) + 1)

        # ######################   File to save: pop_EIF_v.dat (OF_pop_EIF_v)
        # Column: pop_EIF/0/EIF_cond_exp_isfa_ista_pop_EIF/v
        h(' objectvar v_pop_EIF_0_EIF_cond_exp_isfa_ista_pop_EIF_v_OF_pop_EIF_v ')
        h(' { v_pop_EIF_0_EIF_cond_exp_isfa_ista_pop_EIF_v_OF_pop_EIF_v = new Vector() } ')
        h(' { v_pop_EIF_0_EIF_cond_exp_isfa_ista_pop_EIF_v_OF_pop_EIF_v.record(&pop_EIF[0].v(0.5)) } ')
        h.v_pop_EIF_0_EIF_cond_exp_isfa_ista_pop_EIF_v_OF_pop_EIF_v.resize((h.tstop * h.steps_per_ms) + 1)

        # ######################   File to save: pop_post2_v.dat (OF_pop_post2_v)
        # Column: pop_post2/0/IF_cond_alpha_pop_post2/v
        h(' objectvar v_pop_post2_0_IF_cond_alpha_pop_post2_v_OF_pop_post2_v ')
        h(' { v_pop_post2_0_IF_cond_alpha_pop_post2_v_OF_pop_post2_v = new Vector() } ')
        h(' { v_pop_post2_0_IF_cond_alpha_pop_post2_v_OF_pop_post2_v.record(&pop_post2[0].v(0.5)) } ')
        h.v_pop_post2_0_IF_cond_alpha_pop_post2_v_OF_pop_post2_v.resize((h.tstop * h.steps_per_ms) + 1)

        # ######################   File to save: pop_IF_curr_alpha_v.dat (OF_pop_IF_curr_alpha_v)
        # Column: pop_IF_curr_alpha/0/IF_curr_alpha_pop_IF_curr_alpha/v
        h(' objectvar v_pop_IF_curr_alpha_0_IF_curr_alpha_pop_IF_curr_alpha_v_OF_pop_IF_curr_alpha_v ')
        h(' { v_pop_IF_curr_alpha_0_IF_curr_alpha_pop_IF_curr_alpha_v_OF_pop_IF_curr_alpha_v = new Vector() } ')
        h(' { v_pop_IF_curr_alpha_0_IF_curr_alpha_pop_IF_curr_alpha_v_OF_pop_IF_curr_alpha_v.record(&pop_IF_curr_alpha[0].v(0.5)) } ')
        h.v_pop_IF_curr_alpha_0_IF_curr_alpha_pop_IF_curr_alpha_v_OF_pop_IF_curr_alpha_v.resize((h.tstop * h.steps_per_ms) + 1)

        # ######################   File to save: pop_IF_cond_alpha_v.dat (OF_pop_IF_cond_alpha_v)
        # Column: pop_IF_cond_alpha/0/IF_cond_alpha_pop_IF_cond_alpha/v
        h(' objectvar v_pop_IF_cond_alpha_0_IF_cond_alpha_pop_IF_cond_alpha_v_OF_pop_IF_cond_alpha_v ')
        h(' { v_pop_IF_cond_alpha_0_IF_cond_alpha_pop_IF_cond_alpha_v_OF_pop_IF_cond_alpha_v = new Vector() } ')
        h(' { v_pop_IF_cond_alpha_0_IF_cond_alpha_pop_IF_cond_alpha_v_OF_pop_IF_cond_alpha_v.record(&pop_IF_cond_alpha[0].v(0.5)) } ')
        h.v_pop_IF_cond_alpha_0_IF_cond_alpha_pop_IF_cond_alpha_v_OF_pop_IF_cond_alpha_v.resize((h.tstop * h.steps_per_ms) + 1)

        # ######################   File to save: pop_post1_v.dat (OF_pop_post1_v)
        # Column: pop_post1/0/IF_cond_exp_pop_post1/v
        h(' objectvar v_pop_post1_0_IF_cond_exp_pop_post1_v_OF_pop_post1_v ')
        h(' { v_pop_post1_0_IF_cond_exp_pop_post1_v_OF_pop_post1_v = new Vector() } ')
        h(' { v_pop_post1_0_IF_cond_exp_pop_post1_v_OF_pop_post1_v.record(&pop_post1[0].v(0.5)) } ')
        h.v_pop_post1_0_IF_cond_exp_pop_post1_v_OF_pop_post1_v.resize((h.tstop * h.steps_per_ms) + 1)

        # ######################   File to save: time.dat (time)
        # Column: time
        h(' objectvar v_time ')
        h(' { v_time = new Vector() } ')
        h(' { v_time.record(&t) } ')
        h.v_time.resize((h.tstop * h.steps_per_ms) + 1)

        # ######################   File to save: pop_HH_cond_exp_v.dat (OF_pop_HH_cond_exp_v)
        # Column: pop_HH_cond_exp/0/HH_cond_exp_pop_HH_cond_exp/v
        h(' objectvar v_pop_HH_cond_exp_0_HH_cond_exp_pop_HH_cond_exp_v_OF_pop_HH_cond_exp_v ')
        h(' { v_pop_HH_cond_exp_0_HH_cond_exp_pop_HH_cond_exp_v_OF_pop_HH_cond_exp_v = new Vector() } ')
        h(' { v_pop_HH_cond_exp_0_HH_cond_exp_pop_HH_cond_exp_v_OF_pop_HH_cond_exp_v.record(&pop_HH_cond_exp[0].v(0.5)) } ')
        h.v_pop_HH_cond_exp_0_HH_cond_exp_pop_HH_cond_exp_v_OF_pop_HH_cond_exp_v.resize((h.tstop * h.steps_per_ms) + 1)

        # ######################   File to save: pop_IF_cond_exp_v.dat (OF_pop_IF_cond_exp_v)
        # Column: pop_IF_cond_exp/0/IF_cond_exp_pop_IF_cond_exp/v
        h(' objectvar v_pop_IF_cond_exp_0_IF_cond_exp_pop_IF_cond_exp_v_OF_pop_IF_cond_exp_v ')
        h(' { v_pop_IF_cond_exp_0_IF_cond_exp_pop_IF_cond_exp_v_OF_pop_IF_cond_exp_v = new Vector() } ')
        h(' { v_pop_IF_cond_exp_0_IF_cond_exp_pop_IF_cond_exp_v_OF_pop_IF_cond_exp_v.record(&pop_IF_cond_exp[0].v(0.5)) } ')
        h.v_pop_IF_cond_exp_0_IF_cond_exp_pop_IF_cond_exp_v_OF_pop_IF_cond_exp_v.resize((h.tstop * h.steps_per_ms) + 1)

        self.initialized = False

        self.sim_end = -1 # will be overwritten

    def run(self):

        self.initialized = True
        sim_start = time.time()
        print("Running a simulation of %sms (dt = %sms; seed=%s)" % (h.tstop, h.dt, self.seed))

        h.run()

        self.sim_end = time.time()
        sim_time = self.sim_end - sim_start
        print("Finished NEURON simulation in %f seconds (%f mins)..."%(sim_time, sim_time/60.0))

        self.save_results()


    def advance(self):

        if not self.initialized:
            h.finitialize()
            self.initialized = True

        h.fadvance()


    ###############################################################################
    # Hash function to use in generation of random value
    # This is copied from NetPyNE: https://github.com/Neurosim-lab/netpyne/blob/master/netpyne/simFuncs.py
    ###############################################################################
    def _id32 (self,obj): 
        return int(hashlib.md5(obj).hexdigest()[0:8],16)  # convert 8 first chars of md5 hash in base 16 to int


    ###############################################################################
    # Initialize the stim randomizer
    # This is copied from NetPyNE: https://github.com/Neurosim-lab/netpyne/blob/master/netpyne/simFuncs.py
    ###############################################################################
    def _init_stim_randomizer(self,rand, stimType, gid, seed): 
        rand.Random123(self._id32(stimType), gid, seed)


    def save_results(self):

        print("Saving results at t=%s..."%h.t)

        if self.sim_end < 0: self.sim_end = time.time()


        # ######################   File to save: time.dat (time)
        py_v_time = [ t/1000 for t in h.v_time.to_python() ]  # Convert to Python list for speed...

        f_time_f2 = open('time.dat', 'w')
        num_points = len(py_v_time)  # Simulation may have been stopped before tstop...

        for i in range(num_points):
            f_time_f2.write('%f'% py_v_time[i])  # Save in SI units...
        f_time_f2.close()
        print("Saved data to: time.dat")

        # ######################   File to save: pop_IF_curr_exp_v.dat (OF_pop_IF_curr_exp_v)
        py_v_pop_IF_curr_exp_0_IF_curr_exp_pop_IF_curr_exp_v_OF_pop_IF_curr_exp_v = [ float(x  / 1000.0) for x in h.v_pop_IF_curr_exp_0_IF_curr_exp_pop_IF_curr_exp_v_OF_pop_IF_curr_exp_v.to_python() ]  # Convert to Python list for speed, variable has dim: voltage

        f_OF_pop_IF_curr_exp_v_f2 = open('pop_IF_curr_exp_v.dat', 'w')
        num_points = len(py_v_time)  # Simulation may have been stopped before tstop...

        for i in range(num_points):
            f_OF_pop_IF_curr_exp_v_f2.write('%e\t%e\t\n' % (py_v_time[i], py_v_pop_IF_curr_exp_0_IF_curr_exp_pop_IF_curr_exp_v_OF_pop_IF_curr_exp_v[i], ))
        f_OF_pop_IF_curr_exp_v_f2.close()
        print("Saved data to: pop_IF_curr_exp_v.dat")

        # ######################   File to save: pop_EIF_v.dat (OF_pop_EIF_v)
        py_v_pop_EIF_0_EIF_cond_exp_isfa_ista_pop_EIF_v_OF_pop_EIF_v = [ float(x  / 1000.0) for x in h.v_pop_EIF_0_EIF_cond_exp_isfa_ista_pop_EIF_v_OF_pop_EIF_v.to_python() ]  # Convert to Python list for speed, variable has dim: voltage

        f_OF_pop_EIF_v_f2 = open('pop_EIF_v.dat', 'w')
        num_points = len(py_v_time)  # Simulation may have been stopped before tstop...

        for i in range(num_points):
            f_OF_pop_EIF_v_f2.write('%e\t%e\t\n' % (py_v_time[i], py_v_pop_EIF_0_EIF_cond_exp_isfa_ista_pop_EIF_v_OF_pop_EIF_v[i], ))
        f_OF_pop_EIF_v_f2.close()
        print("Saved data to: pop_EIF_v.dat")

        # ######################   File to save: pop_post2_v.dat (OF_pop_post2_v)
        py_v_pop_post2_0_IF_cond_alpha_pop_post2_v_OF_pop_post2_v = [ float(x  / 1000.0) for x in h.v_pop_post2_0_IF_cond_alpha_pop_post2_v_OF_pop_post2_v.to_python() ]  # Convert to Python list for speed, variable has dim: voltage

        f_OF_pop_post2_v_f2 = open('pop_post2_v.dat', 'w')
        num_points = len(py_v_time)  # Simulation may have been stopped before tstop...

        for i in range(num_points):
            f_OF_pop_post2_v_f2.write('%e\t%e\t\n' % (py_v_time[i], py_v_pop_post2_0_IF_cond_alpha_pop_post2_v_OF_pop_post2_v[i], ))
        f_OF_pop_post2_v_f2.close()
        print("Saved data to: pop_post2_v.dat")

        # ######################   File to save: pop_IF_curr_alpha_v.dat (OF_pop_IF_curr_alpha_v)
        py_v_pop_IF_curr_alpha_0_IF_curr_alpha_pop_IF_curr_alpha_v_OF_pop_IF_curr_alpha_v = [ float(x  / 1000.0) for x in h.v_pop_IF_curr_alpha_0_IF_curr_alpha_pop_IF_curr_alpha_v_OF_pop_IF_curr_alpha_v.to_python() ]  # Convert to Python list for speed, variable has dim: voltage

        f_OF_pop_IF_curr_alpha_v_f2 = open('pop_IF_curr_alpha_v.dat', 'w')
        num_points = len(py_v_time)  # Simulation may have been stopped before tstop...

        for i in range(num_points):
            f_OF_pop_IF_curr_alpha_v_f2.write('%e\t%e\t\n' % (py_v_time[i], py_v_pop_IF_curr_alpha_0_IF_curr_alpha_pop_IF_curr_alpha_v_OF_pop_IF_curr_alpha_v[i], ))
        f_OF_pop_IF_curr_alpha_v_f2.close()
        print("Saved data to: pop_IF_curr_alpha_v.dat")

        # ######################   File to save: pop_IF_cond_alpha_v.dat (OF_pop_IF_cond_alpha_v)
        py_v_pop_IF_cond_alpha_0_IF_cond_alpha_pop_IF_cond_alpha_v_OF_pop_IF_cond_alpha_v = [ float(x  / 1000.0) for x in h.v_pop_IF_cond_alpha_0_IF_cond_alpha_pop_IF_cond_alpha_v_OF_pop_IF_cond_alpha_v.to_python() ]  # Convert to Python list for speed, variable has dim: voltage

        f_OF_pop_IF_cond_alpha_v_f2 = open('pop_IF_cond_alpha_v.dat', 'w')
        num_points = len(py_v_time)  # Simulation may have been stopped before tstop...

        for i in range(num_points):
            f_OF_pop_IF_cond_alpha_v_f2.write('%e\t%e\t\n' % (py_v_time[i], py_v_pop_IF_cond_alpha_0_IF_cond_alpha_pop_IF_cond_alpha_v_OF_pop_IF_cond_alpha_v[i], ))
        f_OF_pop_IF_cond_alpha_v_f2.close()
        print("Saved data to: pop_IF_cond_alpha_v.dat")

        # ######################   File to save: pop_post1_v.dat (OF_pop_post1_v)
        py_v_pop_post1_0_IF_cond_exp_pop_post1_v_OF_pop_post1_v = [ float(x  / 1000.0) for x in h.v_pop_post1_0_IF_cond_exp_pop_post1_v_OF_pop_post1_v.to_python() ]  # Convert to Python list for speed, variable has dim: voltage

        f_OF_pop_post1_v_f2 = open('pop_post1_v.dat', 'w')
        num_points = len(py_v_time)  # Simulation may have been stopped before tstop...

        for i in range(num_points):
            f_OF_pop_post1_v_f2.write('%e\t%e\t\n' % (py_v_time[i], py_v_pop_post1_0_IF_cond_exp_pop_post1_v_OF_pop_post1_v[i], ))
        f_OF_pop_post1_v_f2.close()
        print("Saved data to: pop_post1_v.dat")

        # ######################   File to save: pop_HH_cond_exp_v.dat (OF_pop_HH_cond_exp_v)
        py_v_pop_HH_cond_exp_0_HH_cond_exp_pop_HH_cond_exp_v_OF_pop_HH_cond_exp_v = [ float(x  / 1000.0) for x in h.v_pop_HH_cond_exp_0_HH_cond_exp_pop_HH_cond_exp_v_OF_pop_HH_cond_exp_v.to_python() ]  # Convert to Python list for speed, variable has dim: voltage

        f_OF_pop_HH_cond_exp_v_f2 = open('pop_HH_cond_exp_v.dat', 'w')
        num_points = len(py_v_time)  # Simulation may have been stopped before tstop...

        for i in range(num_points):
            f_OF_pop_HH_cond_exp_v_f2.write('%e\t%e\t\n' % (py_v_time[i], py_v_pop_HH_cond_exp_0_HH_cond_exp_pop_HH_cond_exp_v_OF_pop_HH_cond_exp_v[i], ))
        f_OF_pop_HH_cond_exp_v_f2.close()
        print("Saved data to: pop_HH_cond_exp_v.dat")

        # ######################   File to save: pop_IF_cond_exp_v.dat (OF_pop_IF_cond_exp_v)
        py_v_pop_IF_cond_exp_0_IF_cond_exp_pop_IF_cond_exp_v_OF_pop_IF_cond_exp_v = [ float(x  / 1000.0) for x in h.v_pop_IF_cond_exp_0_IF_cond_exp_pop_IF_cond_exp_v_OF_pop_IF_cond_exp_v.to_python() ]  # Convert to Python list for speed, variable has dim: voltage

        f_OF_pop_IF_cond_exp_v_f2 = open('pop_IF_cond_exp_v.dat', 'w')
        num_points = len(py_v_time)  # Simulation may have been stopped before tstop...

        for i in range(num_points):
            f_OF_pop_IF_cond_exp_v_f2.write('%e\t%e\t\n' % (py_v_time[i], py_v_pop_IF_cond_exp_0_IF_cond_exp_pop_IF_cond_exp_v_OF_pop_IF_cond_exp_v[i], ))
        f_OF_pop_IF_cond_exp_v_f2.close()
        print("Saved data to: pop_IF_cond_exp_v.dat")

        save_end = time.time()
        save_time = save_end - self.sim_end
        print("Finished saving results in %f seconds"%(save_time))

        print("Done")

        quit()


if __name__ == '__main__':

    ns = NeuronSimulation(tstop=500.0, dt=0.001, seed=12345)

    ns.run()

