TITLE Mod file for component: Component(id=syn__pop_EIF__TO__pop_post1 type=expCondSynapse)

COMMENT

    This NEURON file has been generated by org.neuroml.export (see https://github.com/NeuroML/org.neuroml.export)
         org.neuroml.export  v1.5.3
         org.neuroml.model   v1.5.3
         jLEMS               v0.9.9.0

ENDCOMMENT

NEURON {
    POINT_PROCESS syn__pop_EIF__TO__pop_post1
    RANGE e_rev                             : parameter
    RANGE tau_syn                           : parameter
    RANGE MSEC                              : parameter
    RANGE MVOLT                             : parameter
    RANGE NAMP                              : parameter
    
    RANGE i                                 : exposure
    
    
    NONSPECIFIC_CURRENT i 
    
}

UNITS {
    
    (nA) = (nanoamp)
    (uA) = (microamp)
    (mA) = (milliamp)
    (A) = (amp)
    (mV) = (millivolt)
    (mS) = (millisiemens)
    (uS) = (microsiemens)
    (molar) = (1/liter)
    (kHz) = (kilohertz)
    (mM) = (millimolar)
    (um) = (micrometer)
    (umol) = (micromole)
    (S) = (siemens)
    
}

PARAMETER {
    
    e_rev = 0 
    tau_syn = 5 
    MSEC = 1 (ms)
    MVOLT = 1 (mV)
    NAMP = 1 (nA)
}

ASSIGNED {
    ? Standard Assigned variables with baseSynapse
    v (mV)
    celsius (degC)
    temperature (K)
    
    i (nA)                                 : derived variable
    rate_g (/ms)
    
}

STATE {
    g  
    
}

INITIAL {
    temperature = celsius + 273.15
    
    rates()
    rates() ? To ensure correct initialisation.
    
}

BREAKPOINT {
    
    SOLVE states METHOD cnexp
    
    
}

NET_RECEIVE(weight) {
    
    : paramMappings . : {syn__pop_EIF__TO__pop_post1={g=g, e_rev=e_rev, tau_syn=tau_syn, MSEC=MSEC, MVOLT=MVOLT, NAMP=NAMP, i=i}}
    : state_discontinuity(g, g  +weight) : From syn__pop_EIF__TO__pop_post1
    g = g  +weight : From syn__pop_EIF__TO__pop_post1
    
}

DERIVATIVE states {
    rates()
    g' = rate_g 
    
}

PROCEDURE rates() {
    
    i = -1 * g  * (  e_rev   - (v/  MVOLT  )) *  NAMP ? evaluable
    rate_g = -  g   / (  tau_syn  *  MSEC  ) ? Note units of all quantities used here need to be consistent!
    
     
    
}

